new;
library tools,pgraph;

declare external sigma,beta,R;

proc lorenz(t,u);
  local x,y,z,dx,dy,dz,du;

  x = u[1]; y = u[2]; z = u[3];

  dx = sigma*(y-x);
  dy = -x*z + R*x - y;
  dz = x*y - beta*z;

  du = dx|dy|dz;

  retp(du);
endp;


sigma = 10; beta = 8/3; R = 28;

u0 = 1|1|1;
{t,u,du} = RungeKutta4(&lorenz,u0,0,2,100);
u0 = u[100,.]';
{t,u,du} = RungeKutta4(&lorenz,u0,0,20,1000);

graphset;
  _pdate = ""; _pnum = 2; _pnumht = 0.18;  _paxht = 0.18;
  fonts("simplex simgrma");
  title("Lorenz model");
  xlabel("x");
  ylabel("y");
  zlabel("z");
  xyz(u[.,1],u[.,2],u[.,3]);
