new;
library tools,pgraph;

declare external a,b,c,d;

proc lvg(t,z);
  local x,y,dz;

  x = z[1];
  y = z[2];

  dz = a*x - b*x*y           |
       -c*y + d*x*y          ;

  retp(dz);
endp;

a = 4; b = 2; c = 3; d = 1;

x = {};
y = {};

i = 0.1;
do until i > 1.5;
  z0 = i|i;
  {t,z,dz} = RungeKutta4(&lvg,z0,0,3,500);
  x = x~z[.,1];
  y = y~z[.,2];
  i = i + 0.1;
endo;

graphset;
  _pnum = 2; _pdate = "";
  fonts("simplex simgrma");
  title("Lotka-Volterra-Godwin model (a=4, b=2, c=3, d=1)"\
        "\Ldx/dt = a*x -b*x*y "\
        "\Ldy/dt = -c*y +d*x*y");
  xlabel("x");
  ylabel("y");
  xy(x,y);


