new;
library pgraph;

proc (2) = sierpinski(x0,y0,N);
  local x,y,u,i,ui,xi,yi;

  x = zeros(N,1);
  y = zeros(N,1);

  xi = x0;
  yi = y0;

  u = rndu(N,1);

  i = 1;
  do until i > N;
    ui = u[i];

    if ui < 0.333;

      xi = 0.5*(xi+320);
      yi = 0.5*(yi+1);

    elseif ui < 0.666;

      xi = 0.5*(xi+1);
      yi = 0.5*(yi+200);

    else;

      xi = 0.5*(xi+640);
      yi = 0.5*(yi+200);

    endif;

    x[i] = xi; y[i] = yi;

    i = i + 1;
  endo;

  retp(x,y);
endp;


N = 3000;
{x,y} = Sierpinski(2,3,N);
e = ones(N,1);


graphset;
  _pdate = ""; _paxes = 0;
  _pline = e.*(4~6) ~ x ~ y  ~ e.*(0.1~0~2*pi~7~10);
  scale(0|640,0|200);
  draw;

