new;
library tools,pgraph;

output file = tools4.out reset;

/* creation of regular daily dates */

dates = calendar_31dpm(0,19960315,19970315);
print dates';


/* A first example */

let X[6,2] =
        19970101 10
        19970102 5
        19970103 7
        19970107 8
        19970110 9
        19970112 -5;

y1 = calendar_31dpm(x,0,0);
print y1;

y2 = calendar_31dpm(x,19961228,0);
print y2;


/* A second example: merging 2 irregular daily datasets */

let X1[6,2] =
        19970101 10
        19970102 5
        19970103 7
        19970107 8
        19970110 9
        19970115 -5;

let X2[10,2] =
        19970103 1
        19970104 2
        19970105 3
        19970106 4
        19970107 5
        19970108 6
        19970109 7
        19970110 8
        19970113 9
        19970114 10;

tstart = 19970101;
tend = 19970115;
y1 = calendar_31dpm(x1,tstart,tend);
y2 = calendar_31dpm(x2,tstart,tend);

print y1~y2[.,2];

output off;

/* third example: daily data graph */

data = loadd("demfrf");


y = calendar_31dpm(data,0,0);
z = Data_interpolation(y);
Nobs = rows(y);

graphset;
  _pdate = ""; _pnum = 2;
  let xlab = "1994" "1995" "1996" "1997";
  asclabel(xlab,0);
  xtics(1,Nobs,31*12,12);

  title("without interpolation");
  xy(seqa(1,1,Nobs),y[.,2]);

  title("with interpolation");
  xy(seqa(1,1,Nobs),z[.,2]);

y = calendar_31dpm(data,19950101,19951231);
z = Data_interpolation(y);
Nobs = rows(y);

graphset;
  _pdate = ""; _pnum = 2;
  let xlab[12,1] = "jan" "feb" "mar"
                   "apr" "may" "jun"
                   "jul" "aou" "sep"
                   "oct" "nov" "dec" ;
  asclabel(xlab,0);
  xtics(1,Nobs,31,0);

  title("without interpolation");
  xy(seqa(1,1,Nobs),y[.,2]);

  title("with interpolation");
  xy(seqa(1,1,Nobs),z[.,2]);


